/*
 * Funkcie pre prcu s LCD
 */


#ifndef APPDISPLAY_H_
#define APPDISPLAY_H_

#include "stdint-gcc.h"
#include "stdbool.h"

// Inicializuje displej
void usbapp_lcd_initialize(void);

// Vyist displej
void usbapp_lcd_clear(uint32_t color);

// Zape riadok na displej
void usbapp_lcd_write_line_col(const char * line, uint32_t color);

// Zapne displej
void usbapp_lcd_on(void);

// Vypne displej
void usbapp_lcd_off(void);

// Vypne podsvietenie
void usbapp_lcd_backlight_off(void);

// Nastav level podsvietenia
void usbapp_lcd_set_backlight(uint32_t level);

// Vykresl bitmapu
void usbapp_lcd_draw_bitmap(uint32_t x, uint32_t y, uint32_t width, uint32_t height,
	uint16_t * bitmap);

// Skonvertuje 24-bitov farbu na 16-bitov
uint16_t rgb24_to_rgb16(uint32_t ul_color);

// Zska hodnotu urujcu, i je displej zapnut
bool usbapp_lcd_is_on(void);

// Zska hodnotu urujcu, i je podsvietenie zapnut
bool usbapp_lcd_is_backlight_on(void);

// Zska intenzitu podsvietenia
uint8_t usbapp_lcd_get_backlight(void);

// Zska hodnotu skrolovania displeja
uint16_t usbapp_lcd_get_scroll(void);

// Nastav hodnotu skrolovania displeja
void usbapp_lcd_set_scroll(uint16_t scroll);

// Skontroluje, i sa dan koordinty nachdzaj v priestore obrazovky
bool usbapp_lcd_check_coords(uint16_t posX, uint16_t posY, uint16_t width, uint16_t height);

// Vykresl text na obrazovku
void usbapp_lcd_draw_text(const char * text, uint16_t posX, uint16_t posY, uint32_t color);

#endif