#include "AppPushButtons.h"
#include "asf.h"

// Prznak urujci, i sa stav tlaidiel od poslednho merania zmenil
static volatile bool __apppushbuttons_changed = false;
// Stav tlaidiel
static volatile uint8_t __apppushbuttons_buttons = 0;

// Zska hodnotu urujcu, i sa od poslednho merania zmenil stav tlaidiel
bool usbapp_pushbuttons_changed(void)
{
	return __apppushbuttons_changed;
}

// Odstrni prznak toho, i sa od poslednho merania zmenil stav tlaidiel
void usbapp_pushbuttons_clear_changed(void)
{
	__apppushbuttons_changed = false;
}

// Zska hodnotu, ktor tlaidl s stlaen
uint8_t usbapp_pushbuttons_buttons(void)
{
	return __apppushbuttons_buttons;
}

// Aktualizuje stav tlaidiel
void usbapp_pushbuttons_measure(void)
{
	static bool pressed;
	
	pressed = gpio_pin_is_low(GPIO_PUSH_BUTTON_1);
	if (pressed && !(__apppushbuttons_buttons & PushButton_Left))
	{
		__apppushbuttons_buttons |= PushButton_Left;
		__apppushbuttons_changed = true;
	}
	else if (!pressed && (__apppushbuttons_buttons & PushButton_Left))
	{
		__apppushbuttons_buttons &= ~(PushButton_Left);
		__apppushbuttons_changed = true;
	}
	
	pressed = gpio_pin_is_low(GPIO_PUSH_BUTTON_2);
	if (pressed && !(__apppushbuttons_buttons & PushButton_Right))
	{
		__apppushbuttons_buttons |= PushButton_Right;
		__apppushbuttons_changed = true;
	}
	else if (!pressed && (__apppushbuttons_buttons & PushButton_Right))
	{
		__apppushbuttons_buttons &= ~(PushButton_Right);
		__apppushbuttons_changed = true;
	}
}